#include <semaphore.h>
#include <unistd.h>
#include "list.hpp"    // list implementation
#include "globals.hpp" // lists, sems, muts
#include "consumer.hpp"

int consume(block* c);

void *consumer (void *) {
   block* c;
   while (true) {
      wait(sem_list2);
      wait(mut_list2);
      //* c:=unlink(list-2);
      c = unlink(list2);
      signal(mut_list2);

      //* consume_information_in_block(c)
      consume(c);

      wait(mut_freelist);
      //* link(c, freelist)
      link(c, freelist);
      signal(mut_freelist);
      signal(sem_freelist);

   }
   return nullptr;
}

int consume(block *c) {
   return c->data;
}
