#include <semaphore.h>
#include <unistd.h>
#include "list.hpp"    // list implementation
#include "globals.hpp" // lists, sems, muts
#include "producer.hpp"

void produce(block* b);

void *producer (void *) {
   block *b;
   while (true)
   {
      int v;
      while(sem_getvalue(&sem_freelist, &v), v <= 1);
      wait(sem_freelist); // wait for freelist not empty
      wait(mut_freelist); // lock freelist
      //* b:= unlink(freelist);
      b = unlink(freelist);
      signal(mut_freelist); // unlock freelist

      //* produce_information_in_block(b)
      produce(b);

      wait(mut_list1); // lock mutex
      //* link(b, list1);
      link(b, list1);
      signal(mut_list1); // unlock mutex
      signal(sem_list1); // signal new item on list
   }
   return nullptr;
}

void produce(block *b) {
   return;
}
